define("screens/chooseLevel", [
	"utils/Background",
	"sdk/EventManager",
	"sdk/DisplayObject",
	"sdk/TextField",
	"sdk/GameData",
	"sdk/Tween",
	"text/Font",
	"text/Gradient"
], 
function (Background, EventManager, DisplayObject, TextField, GameData, Tween, Font, Gradient){
	var screen = function(){
		var thisRef = this,
			// Local
			isLevelOverlay = false,
			isArtistOverlay = false,
			selectedLevel = 0,
			levels = {
				0: { x: 757, y: 428, color: "#A384FA", glow: "rgba(145, 73, 242, 0.5)", radius: 103, font: new Font("level4Font") },
				1: { x: 336, y: 147, color: "#91FF5B", glow: "rgba(60, 181, 0, 0.5)", radius: 104, font: new Font("level1Font") },
				2: { x: 245, y: 303, color: "#FF4EF9", glow: "rgba(147, 0, 142, 0.5)", radius: 111, font: new Font("level2Font") },
				3: { x: 294, y: 475, color: "#FBDC2F", glow: "rgba(174, 148, 0, 0.5)", radius: 126, font: new Font("level3Font") }
			},
			tokens = {
				1: { x: 72, y: 430, thumbnail: new DisplayObject("levelToken1"), icon: new DisplayObject("levelIcon1") },
				2: { x: 155, y: 430, thumbnail: new DisplayObject("levelToken2"), icon: new DisplayObject("levelIcon2") },
				3: { x: 236, y: 430, thumbnail: new DisplayObject("levelToken3"), icon: new DisplayObject("levelIcon3") },
				4: { x: 317, y: 430, thumbnail: new DisplayObject("levelToken4"), icon: new DisplayObject("levelIcon4") },
				5: { x: 396, y: 430, thumbnail: new DisplayObject("levelToken5"), icon: new DisplayObject("levelIcon5") }
			},
			// Fonts
			titleGradient = new Gradient(0, 0, 0, 70),
			overlayTitleGradient = new Gradient(0, 0, 0, 30),
			titleFont = new Font("titleFont"),
			overlayNumberFont = new Font("overlayNumberFont"),
			overlayTitleFont = new Font("overlayTitleFont"),
			overlayTextLeftFont = new Font("overlayTextLeftFont"),
			overlayTextRightFont = new Font("overlayTextRightFont"),
			// Elements
			title = new TextField("title"),
			watermark = new DisplayObject("watermark"),
			ardy = new DisplayObject("ardy"),
			artistBtnGlow = new DisplayObject("artistBtnGlow"),
			artistBtn = new DisplayObject("artist"),
			switchBtn = new DisplayObject("switchBtn"),
			switchBtnLabel = new TextField("switchBtnLabel"),
			overlayLevelHolder = new DisplayObject("overlayLevelHolder"),
				overlayLevelBg = new DisplayObject("overlayLevelBg"),
				overlayLevelPlayGlow = new DisplayObject("overlayLevelPlayGlow"),
					overlayLevelPlay = new DisplayObject("overlayLevelPlay"),
						overlayLevelPlayFake = new DisplayObject("overlayLevelPlayFake"),
				overlayLevelPanel = new DisplayObject("overlayLevelPanel"),
					overlayLevelHeader = new DisplayObject("overlayLevelHeader"),
						overlayLevelHeaderNumber = new TextField("overlayLevelHeaderNumber"),
						overlayLevelHeaderTitle = new TextField("overlayLevelHeaderTitle"),
					overlayLevelClose = new DisplayObject("levelClose"),
					overlayLevelStar = new DisplayObject("overlayLevelStar"),
					overlayLevelHighscore = new TextField("overlayLevelHighscore"),
					overlayLevelHighscoreValue = new TextField("overlayLevelHighscoreValue"),
					overlayLevelRating = new TextField("overlayLevelRating"),
					overlayLevelNote = new TextField("overlayLevelNote"),
					overlayLevelNoteValue = new TextField("overlayLevelNoteValue"),
					overlayLevelToken = new TextField("overlayLevelToken"),
					overlayLevelCheck = new DisplayObject("overlayLevelCheck"),
			overlayArtistHolder = new DisplayObject("overlayArtistHolder")
		;

		var preload = new DisplayObject("preload");
			preload.loadBitmap("media/images/screens/chooseLevel/level" + 1 + "Gold.png");
			preload.loadBitmap("media/images/screens/chooseLevel/level" + 2 + "Gold.png");
			preload.loadBitmap("media/images/screens/chooseLevel/level" + 3 + "Gold.png");
			preload.loadBitmap("media/images/screens/chooseLevel/level" + 1 + ".png");
			preload.loadBitmap("media/images/screens/chooseLevel/level" + 2 + ".png");
			preload.loadBitmap("media/images/screens/chooseLevel/level" + 3 + ".png");


		Background.set("media/images/backgrounds/chooseLevelBg.jpg");

		// Fonts
		titleGradient.addColorStop(0, "#c69057").addColorStop(0.5, "#f7d061").addColorStop(0.6, "#FFF").addColorStop(0.67, "#ffdc55").addColorStop(1, "#ffdc76");
		overlayTitleGradient.addColorStop(0, "#c69057").addColorStop(0.5, "#f7d061").addColorStop(0.6, "#FFF").addColorStop(0.67, "#ffdc55").addColorStop(1, "#ffdc76");


		/*var pellet = new DisplayObject("pellet");
			pellet.loadBitmap("media/images/localized/choose2014.png");
			pellet.x = 26;
			pellet.y = 9;
		this.addChild(pellet);*/

		var date = new DisplayObject("date");
			date.loadBitmap("media/images/screens/chooseLevel/2014.png");
			date.x = 459;
			date.y = 495;
		this.addChild(date);

		titleFont.font = "60px NexaBold";
		titleFont.fillStyle = titleGradient.export();
		titleFont.textBaseline = "alphabetical";
		titleFont.paddingTop = 60;
		titleFont.textAlign = "center";

		overlayNumberFont.font = "54px GeomGraphicSemiBoldItalic";
		overlayNumberFont.fillStyle = "#5F5F5F";
		overlayNumberFont.textBaseline = "middle";
		overlayNumberFont.paddingTop = 74;
		overlayNumberFont.textAlign = "center";

		overlayTitleFont.font = "30px NexaBold";
		overlayTitleFont.fillStyle = overlayTitleGradient.export();
		overlayTitleFont.textBaseline = "alphabetical";
		overlayTitleFont.paddingTop = 30;
		overlayTitleFont.textAlign = "left";
		overlayTitleFont.textWrap = true;

		overlayTextLeftFont.font = "30px NexaBold";
		overlayTextLeftFont.fillStyle = "#000";
		overlayTextLeftFont.textBaseline = "alphabetical";
		overlayTextLeftFont.paddingTop = 30;
		overlayTextLeftFont.textAlign = "left";

		overlayTextRightFont.font = "30px NexaBold";
		overlayTextRightFont.fillStyle = "#000";
		overlayTextRightFont.textBaseline = "alphabetical";
		overlayTextRightFont.paddingTop = 30;
		overlayTextRightFont.textAlign = "right";

		// Default

		title.width = 900;
		title.height = 80;
		title.x = (1136 - title.width) / 2;
		title.y = 68;
		title.font = titleFont;
		title.setStrokeText("ChooseLevelTitle");
		this.addChild(title);

		watermark.loadBitmap("media/images/localized/chooseLevelWatermark.png");
		watermark.x = 902;
		watermark.y = 500;
		this.addChild(watermark);

		ardy.loadBitmap("media/images/screens/chooseLevel/ardy.png");
		ardy.x = 251;
		ardy.y = 162;
		//this.addChild(ardy);

		this.btnMoveUp = function(btn, fromX, fromY, toX, toY, speed){
			setTimeout(function(){ Tween.add(btn, { x: toX, y: toY }, speed, 0.75, function(t){
				Tween.add(t, { x: fromX, y: fromY}, speed, 0.75, function(t){ thisRef.btnMoveUp(t, fromX, fromY, toX, toY,speed); });
			 }); }, 0);
		};

		//must hard compte la position
		this.glowScale = function(btn, fromScaleX, fromScaleY, toScaleX, toScaleY, speed){
			setTimeout(function(){ Tween.add(btn, { scaleX: toScaleX, scaleY: toScaleY, x:btn.x - btn.width*0.25 ,y: btn.y - btn.height*0.25 }, speed, 1, function(t){
				Tween.add(t, { scaleX: fromScaleX, scaleY: fromScaleY, x:btn.x + btn.width*0.25 ,y: btn.y + btn.height*0.25}, speed, 1, function(t){ thisRef.glowScale(t, fromScaleX, fromScaleY, toScaleX, toScaleY,speed); });
			 }); }, 0);
		};

		var toX = [750,344,254,305],
			toY = [430,162,313,478];

		for(var key in levels){
			if(typeof levels[key] != "function"){
				var locked = "Locked";

				levels[key]["font"].font = "54px GeomGraphicSemiBoldItalic";
				levels[key]["font"].fillStyle = "#5F5F5F";
				levels[key]["font"].textBaseline = "middle";
				levels[key]["font"].paddingTop = levels[key].radius * 0.5 + 4;
				levels[key]["font"].textAlign = "center";

				

				var levelBtn = new DisplayObject("level" + key);
					levelBtn.x = levels[key].x;
					levelBtn.y = levels[key].y;
					levelBtn.level = key;

				if(key <= parseInt(GameData.get("levelUnlocked", true), 10) || key == 0){
					locked = "";

					levels[key]["font"].fillStyle = levels[key].color;
					levelBtn.y = levels[key].y+10;
					this.btnMoveUp(levelBtn, levelBtn.x, levelBtn.y, toX[key], toY[key] ,30);
				}
				var isGold = true;
				if(!locked){
					for(var j = 1; j < 6; j++){
						if(GameData.get("level" + key + "Token" + j, true) == "false" || GameData.get("level" + key + "Token" + j, true) == false){
							isGold = false;
						}
					}
					if(key != 0){
						if(isGold){
							levelBtn.loadBitmap("media/images/screens/chooseLevel/level" + key + "Gold.png");
							levels[key]["font"].fillStyle = titleGradient.export();
						}else{
							levels[key]["font"].fillStyle = levels[key].color;
							levelBtn.loadBitmap("media/images/screens/chooseLevel/level" + key + locked + ".png");
						}						
					}else{
						levelBtn.loadBitmap("media/images/screens/chooseLevel/level" + key + locked + ".png");
					}
					
					levelBtn.pressedState = function(){
						//this.loadBitmap("media/images/screens/chooseLevel/level" + key + locked + ".png");

						if(this.level != 0){
							thisRef.showLevelOverlay(this.level);
						}else{
							if(isLevelOverlay || isArtistOverlay) return;
							selectedLevel = 0;
							thisRef.playLevel();
						}
					}
				}else{
					levels[key]["font"].fillStyle = "#5F5F5F";
					levelBtn.loadBitmap("media/images/screens/chooseLevel/level" + key + locked + ".png");
				}

				this.addChild(levelBtn);

				var levelLabel = new TextField("levelLabel" + key);
					levelLabel.width = levels[key].radius;
					levelLabel.height = levels[key].radius;
					levelLabel.font = levels[key].font;
					levelLabel.setFillText("Level" + key);
				levelBtn.addChild(levelLabel);
			}
		}

		artistBtnGlow.loadBitmap("media/images/screens/chooseLevel/artistBtnGlow.png");
		artistBtnGlow.width = 247;
		artistBtnGlow.height = 247;
		artistBtnGlow.x = 823;
		artistBtnGlow.y = 128;
		this.addChild(artistBtnGlow);

		this.glowScale(artistBtnGlow, artistBtnGlow.scaleX, artistBtnGlow.scaleX, 1.5, 1.5, 30);

		artistBtn.loadBitmap("media/images/buttons/btnArtist.png");
		artistBtn.x = 823 + 50;
		artistBtn.y = 128 + 50;
		artistBtn.releasedState = function(){
			this.loadBitmap("media/images/buttons/btnArtist.png");
		};
		artistBtn.pressedState = function(){
			this.loadBitmap("media/images/buttons/btnArtistPressed.png");
		};
		this.addChild(artistBtn);

		switchBtn.loadBitmap("media/images/localized/back2014.png");
		switchBtn.x = 90;
		switchBtn.y = 490;
		this.addChild(switchBtn);

		//this.pulse(artistBtnGlow, 30);

		// Level Overlay

		overlayLevelHolder.alpha = 0;
		overlayLevelHolder.setIndex(2);
		this.addChild(overlayLevelHolder);

		overlayLevelBg.loadBitmap("media/images/screens/chooseLevel/overlayLevel0.png");
		overlayLevelBg.loadBitmap("media/images/screens/chooseLevel/overlayLevel3.png");
		overlayLevelBg.loadBitmap("media/images/screens/chooseLevel/overlayLevel2.png");
		overlayLevelBg.loadBitmap("media/images/screens/chooseLevel/overlayLevel1.png");
		overlayLevelBg.x = 0;
		overlayLevelBg.y = 0;
		overlayLevelHolder.addChild(overlayLevelBg);

		overlayLevelPanel.loadBitmap("media/images/screens/chooseLevel/overlayLevelPanel.png");
		overlayLevelPanel.x = 295;
		overlayLevelPanel.y = 17;
		overlayLevelPanel.alpha = 0;
		overlayLevelHolder.addChild(overlayLevelPanel);

		overlayLevelPlayGlow.loadBitmap("media/images/buttons/btnGlow.png");
		overlayLevelPlayGlow.x = 554;
		overlayLevelPlayGlow.y = 233;
		overlayLevelPlayGlow.alpha = 0;
		overlayLevelPanel.addChild(overlayLevelPlayGlow);

		overlayLevelPlay.loadBitmap("media/images/buttons/btnPlay.png");
		//overlayLevelPlay.x = 40;
		//overlayLevelPlay.y = 40;
		/*overlayLevelPlay.releasedState = function(){
			this.loadBitmap("media/images/buttons/btnPlay.png");
		};
		overlayLevelPlay.pressedState = function(){
			this.loadBitmap("media/images/buttons/btnPlayPressed.png");

			thisRef.playLevel();
		};*/
		overlayLevelPlayGlow.addChild(overlayLevelPlay);

		overlayLevelPlayFake.x = 50;
		overlayLevelPlayFake.y = 50;
		overlayLevelPlayFake.width = 100;
		overlayLevelPlayFake.height = 100;
		overlayLevelPlayFake.releasedState = function(){
			overlayLevelPlay.loadBitmap("media/images/buttons/btnPlay.png");
		};
		overlayLevelPlayFake.pressedState = function(){
			overlayLevelPlay.loadBitmap("media/images/buttons/btnPlayPressed.png");

			thisRef.playLevel();
		};
		overlayLevelPlay.addChild(overlayLevelPlayFake);

		overlayLevelClose.loadBitmap("media/images/screens/chooseLevel/panelClose.png");
		overlayLevelClose.x = 482;
		overlayLevelClose.y = 39;
		overlayLevelClose.releasedState = function(){
			this.loadBitmap("media/images/screens/chooseLevel/panelClose.png");
		};
		overlayLevelClose.pressedState = function(){
			this.loadBitmap("media/images/screens/chooseLevel/panelClose.png");
		};
		overlayLevelPanel.addChild(overlayLevelClose);

		overlayLevelHeader.loadBitmap("media/images/screens/chooseLevel/panelLevel0.png");
		overlayLevelHeader.loadBitmap("media/images/screens/chooseLevel/panelLevel1.png");
		overlayLevelHeader.loadBitmap("media/images/screens/chooseLevel/panelLevel2.png");
		overlayLevelHeader.loadBitmap("media/images/screens/chooseLevel/panelLevel3.png");
		overlayLevelHeader.x = 46;
		overlayLevelHeader.y = 33;
		overlayLevelPanel.addChild(overlayLevelHeader);

		overlayLevelHeaderNumber.width = 141;
		overlayLevelHeaderNumber.height = 141;
		overlayLevelHeaderNumber.font = overlayNumberFont;
		overlayLevelHeader.addChild(overlayLevelHeaderNumber);

		overlayLevelHeaderTitle.width = 310;
		overlayLevelHeaderTitle.height = 100;
		overlayLevelHeaderTitle.x = 186;
		overlayLevelHeaderTitle.y = 58;
		overlayLevelHeaderTitle.font = overlayTitleFont;
		overlayLevelPanel.addChild(overlayLevelHeaderTitle);

		overlayLevelHighscore.width = 200;
		overlayLevelHighscore.height = 80;
		overlayLevelHighscore.x = 100;
		overlayLevelHighscore.y = 190;
		overlayLevelHighscore.font = overlayTextLeftFont;
		overlayLevelPanel.addChild(overlayLevelHighscore);

		overlayLevelHighscoreValue.width = 200;
		overlayLevelHighscoreValue.height = 80;
		overlayLevelHighscoreValue.x = 270;
		overlayLevelHighscoreValue.y = 190;
		overlayLevelHighscoreValue.font = overlayTextRightFont;
		overlayLevelPanel.addChild(overlayLevelHighscoreValue);

		overlayLevelRating.width = 200;
		overlayLevelRating.height = 80;
		overlayLevelRating.x = 100;
		overlayLevelRating.y = 250;
		overlayLevelRating.font = overlayTextLeftFont;
		overlayLevelPanel.addChild(overlayLevelRating);

		overlayLevelStar.loadBitmap("media/images/screens/chooseLevel/star3.png");
		overlayLevelStar.loadBitmap("media/images/screens/chooseLevel/star2.png");
		overlayLevelStar.loadBitmap("media/images/screens/chooseLevel/star1.png");
		overlayLevelStar.loadBitmap("media/images/screens/chooseLevel/star0.png");
		overlayLevelStar.x = 340;
		overlayLevelStar.y = 250;
		overlayLevelPanel.addChild(overlayLevelStar);

		overlayLevelNote.width = 200;
		overlayLevelNote.height = 80;
		overlayLevelNote.x = 100;
		overlayLevelNote.y = 310;
		overlayLevelNote.font = overlayTextLeftFont;
		overlayLevelPanel.addChild(overlayLevelNote);

		overlayLevelNoteValue.width = 200;
		overlayLevelNoteValue.height = 80;
		overlayLevelNoteValue.x = 270;
		overlayLevelNoteValue.y = 310;
		overlayLevelNoteValue.font = overlayTextRightFont;
		overlayLevelPanel.addChild(overlayLevelNoteValue);

		overlayLevelToken.width = 200;
		overlayLevelToken.height = 80;
		overlayLevelToken.x = 100;
		overlayLevelToken.y = 380;
		overlayLevelToken.font = overlayTextLeftFont;
		overlayLevelPanel.addChild(overlayLevelToken);


		var tokenGradient = new Gradient(0,0,0,30);		
			tokenGradient.addColorStop(0, "#c69057").addColorStop(0.5, "#f7d061").addColorStop(0.6, "#FFF").addColorStop(0.67, "#ffdc55").addColorStop(1, "#ffdc76");

		var tokenTxtFont = new Font();
			tokenTxtFont.font = "22px NexaBold";
			tokenTxtFont.fillStyle = tokenGradient.export();
			tokenTxtFont.textBaseline = "alphabetical";
			tokenTxtFont.paddingTop = 22;
			tokenTxtFont.textAlign = "center";
			tokenTxtFont.textWrap = true;
		
		var tokenTxt = new TextField("tokenTxt");
			tokenTxt.width = 560;
			tokenTxt.height = 100;
			tokenTxt.x = 290 - tokenTxt.width * 0.5;
			tokenTxt.y = 530;
			tokenTxt.font = tokenTxtFont;
			tokenTxt.setFillText("replayToken");
			
		overlayLevelPanel.addChild(tokenTxt);

		for(var key in tokens){
			if(typeof tokens[key] != "function"){
				tokens[key]["thumbnail"].loadBitmap("media/images/artists/levelToken" + key + "Inactive.png");
				tokens[key]["thumbnail"].x = tokens[key].x;
				tokens[key]["thumbnail"].y = tokens[key].y;
				overlayLevelPanel.addChild(tokens[key]["thumbnail"]);
			}
		}

		// Artist Overlay

		overlayArtistHolder.alpha = 0;
		overlayArtistHolder.setIndex(3);
		this.addChild(overlayArtistHolder);

		// Methods
		
		this.onload = function(){
			if (!window.bgMusic) {
				window.bgMusic = new Howl({
					urls:[
						'media/music/menu.mp3',
						'media/music/menu.ogg'
					],
					autoplay:true,
					loop:true
				});
				if(GameData.get("muted", true) == "true"){
					window.bgMusic.volume(0);
				}
			}
		};	
		
		this.update = function(){}
		
		this.onunload = function(){
			//Background.reset();
		};

		this.showLevelOverlay = function(level){
			if(isLevelOverlay || isArtistOverlay) return;

			selectedLevel = level;
			tokenTxt.killBuffer();
			for(var j = 1; j < 6; j++){
				if(GameData.get("level" + selectedLevel + "Token" + j, true) == "true"){
					tokenTxt.setFillText("replayTokenAll",{"%%":selectedLevel});
				}
			}

			overlayLevelBg.loadBitmap("media/images/screens/chooseLevel/overlayLevel" + selectedLevel + ".png");
			overlayLevelBg.x = 1136;

			overlayNumberFont.fillStyle = levels[selectedLevel].color;

			overlayLevelHeader.loadBitmap("media/images/screens/chooseLevel/panelLevel" + selectedLevel + ".png");
			overlayLevelHeaderNumber.killBuffer();
			overlayLevelHeaderNumber.setFillText("Level" + selectedLevel);

			//overlayTitleFont.fillStyle = levels[selectedLevel].color;
			overlayLevelHeaderTitle.killBuffer();
			overlayLevelHeaderTitle.setFillText("Level" + selectedLevel + "Title");

			overlayTextLeftFont.fillStyle = levels[selectedLevel].color;
			overlayTextLeftFont.shadowColor = levels[selectedLevel].glow;

			overlayLevelHighscore.setFillText("Highscore");
			overlayLevelRating.setFillText("Rating");
			overlayLevelNote.setFillText("Note");
			overlayLevelToken.setFillText("ArtistTokens");

			overlayTextRightFont.fillStyle = levels[selectedLevel].color;
			overlayTextRightFont.shadowColor = levels[selectedLevel].glow;

			overlayLevelHighscoreValue.setFillText(" " + GameData.get("level" + selectedLevel + "Highscore", true));
			overlayLevelStar.loadBitmap("media/images/screens/chooseLevel/star" + GameData.get("level" + selectedLevel + "Star", true) + ".png");
			overlayLevelNoteValue.setFillText("NoteValue", { "%%": GameData.get("level" + selectedLevel + "Note", true) });

			for(var key in tokens){
				if(typeof tokens[key] != "function"){
					var status = "Inactive",
						icon = "cross";

					if(GameData.get("level" + selectedLevel + "Token" + key,true) == "true"){
						status = "Active";
						icon = "check";
					}

					tokens[key]["thumbnail"].loadBitmap("media/images/artists/levelToken" + key + status + ".png");
					tokens[key]["icon"].loadBitmap("media/images/screens/chooseLevel/" + icon + ".png");
				}
			}

			overlayLevelPanel.alpha = 0;
			overlayLevelHolder.alpha = 1;

			setTimeout(function(){ Tween.add(overlayLevelBg, { x: 0 }, 6, 0.25, function(){
				overlayLevelPanel.alpha = 1;

				thisRef.btnFadeIn();

				isLevelOverlay = true;

			}); }, 50);
		};

		this.btnFadeIn = function(){
			setTimeout(function(){ Tween.add(overlayLevelPlayGlow, { alpha: 1 }, 20, 1, function(){ thisRef.btnFadeOut(); }); }, 100);
		};

		this.btnFadeOut = function(){
			setTimeout(function(){ Tween.add(overlayLevelPlayGlow, { alpha: 0.5 }, 20, 1, function(){ thisRef.btnFadeIn(); }); }, 100);
		};


		this.hideLevelOverlay = function(){
			overlayLevelPanel.alpha = 0;

			setTimeout(function(){ Tween.add(overlayLevelBg, { x: 1136 }, 6, 0.25, function(){
				isLevelOverlay = false;
			}); }, 50);
		};

		this.playLevel = function(){
			if(GameData.get("tutDone", true) == "false"){
				GameData.set("selectedLevel", 0);
			}else{
				GameData.set("selectedLevel", selectedLevel);
			}
			window.bgMusic.unload();
			window.bgMusic = null;
			
			EventManager.broadcast("gotoScreen", "gameplay");
		};

		this.artist = function(){
			if(isLevelOverlay || isArtistOverlay) return;
			EventManager.broadcast("gotoScreen", "collectible");
		};

		this.switchYear = function(){
			if(isLevelOverlay || isArtistOverlay) return;
			EventManager.broadcast("gotoScreen", "chooseLevel2015");
		};
		
		this.binds = {
			"artist": thisRef.artist,
			"levelClose": thisRef.hideLevelOverlay,
			"switchBtn": thisRef.switchYear
		};
	};
	
	return screen;
});