define("screens/end", [
	"utils/Background",
	"sdk/EventManager",
	"sdk/DisplayObject",
	"sdk/TextField",
	"sdk/GameData",
	"sdk/Sound",
	"sdk/Tween",
	"text/Font",
	"text/Gradient"
], 
function (Background, EventManager, DisplayObject, TextField, GameData, Sound, Tween , Font, Gradient){
	var screen = function(){
		var thisRef = this,
			// Local
			isOverlay = false,
			/*tokens = {
				1: { x: 244, y: 154, object: new DisplayObject("token1") },
				2: { x: 173, y: 293, object: new DisplayObject("token2") },
				3: { x: 286, y: 393, object: new DisplayObject("token3") },
				4: { x: 782, y: 172, object: new DisplayObject("token4") },
				5: { x: 728, y: 342, object: new DisplayObject("token5") }
			},*/
			// Styles
			titleFont = new Font("titleFont"),
			textFont = new Font("textFont"),
			endBtnFont = new Font("endBtnFont"),
			overlayTitleFont = new Font("overlayTitleFont"),
			overlayTextFont = new Font("overlayTextFont"),
			overlayBtnFont = new Font("overlayBtnFont"),
			titleGradient = new Gradient(0, 0, 0, 48),
			textGradient = new Gradient(0, 0, 0, 24),
			// Elements
			title = new TextField("title"),
			text = new TextField("text"),
			resetBtn = new DisplayObject("reset"),
				resetLabel = new TextField("resetLabel"),
			continueBtn = new DisplayObject("continue"),
				continueLabel = new TextField("continueLabel"),
			overlayHolder = new DisplayObject("overlayHolder"),
			eraseHolder = new DisplayObject("eraseHolder"),
				overlayTitle = new TextField("overlayTitle"),
				overlayText = new TextField("confirmText"),
				confirmResetBtn = new DisplayObject("confirmReset"),
					confirmResetLabel = new TextField("confirmResetLabel"),
				cancelResetBtn = new DisplayObject("cancelReset"),
					cancelResetLabel = new TextField("cancelResetLabel")
		;
		
		Background.set("media/images/screens/end/bg.jpg");
				
		// Fonts

		titleGradient.addColorStop(0, "#c69057").addColorStop(0.5, "#f7d061").addColorStop(0.6, "#FFF").addColorStop(0.67, "#ffdc55").addColorStop(1, "#ffdc76");
		textGradient.addColorStop(0, "#c69057").addColorStop(0.5, "#f7d061").addColorStop(0.6, "#FFF").addColorStop(0.67, "#ffdc55").addColorStop(1, "#ffdc76");

		titleFont.font = "48px NexaBold";
		titleFont.fillStyle = titleGradient.export();
		titleFont.textBaseline = "alphabetical";
		titleFont.paddingTop = 48;
		titleFont.textAlign = "center";

		textFont.font = "24px NexaBold";
		textFont.fillStyle = textGradient.export();
		textFont.textBaseline = "alphabetical";
		textFont.paddingTop = 24;
		textFont.textAlign = "center";

		endBtnFont.font = "20px NexaBold";
		endBtnFont.fillStyle = "#fff";
		endBtnFont.textBaseline = "alphabetical";
		endBtnFont.paddingTop = 20;
		endBtnFont.textAlign = "center";
		endBtnFont.shadowColor = "60D5FF";
		endBtnFont.shadowBlur = 5;

		overlayTitleFont.font = "56px NexaBold";
		overlayTitleFont.fillStyle = "#60D5FF";
		overlayTitleFont.textBaseline = "alphabetical";
		overlayTitleFont.paddingTop = 56;
		overlayTitleFont.textAlign = "center";

		overlayTextFont.font = "25px NexaBold";
		overlayTextFont.fillStyle = "#60D5FF";
		overlayTextFont.textBaseline = "alphabetical";
		overlayTextFont.paddingTop = 25;
		overlayTextFont.textAlign = "center";
		overlayTextFont.verticalSpacing = 5;
		overlayTextFont.textWrap = true;

		overlayBtnFont.font = "25px NexaBold";
		overlayBtnFont.fillStyle = "#60D5FF";
		overlayBtnFont.textBaseline = "middle";
		overlayBtnFont.paddingTop = 40;
		overlayBtnFont.textAlign = "center";
		
		// Default

		title.width = 900;
		title.height = 100;
		title.x = 568 - (title.width / 2);
		title.y = 78;
		title.font = titleFont;
		title.setStrokeText("EndTitle");
		this.addChild(title);

		text.width = 900;
		text.height = 100;
		text.x = 568 - (title.width / 2);
		text.y = 130;
		text.font = textFont;
		text.setStrokeText("EndText");
		this.addChild(text);

		/*for(var key in tokens){
			if(typeof tokens[key] != "function"){
				tokens[key]["object"].loadBitmap("media/images/artists/collectionToken" + key + ".png");
				tokens[key]["object"].x = tokens[key].x;
				tokens[key]["object"].y = tokens[key].y;
				this.addChild(tokens[key]["object"]);
			}
		}*/

		resetBtn.loadBitmap("media/images/buttons/btnLarge.png");
		resetBtn.x = 78;
		resetBtn.y = 672; 
		resetBtn.alpha = 0;
		resetBtn.releasedState = function(){
			this.loadBitmap("media/images/buttons/btnLarge.png");
		};
		resetBtn.pressedState = function(){
			this.loadBitmap("media/images/buttons/btnLargePressed.png");
		};
		this.addChild(resetBtn);

		resetLabel.width = 238;
		resetLabel.height = 75;
		resetLabel.y = 26;
		resetLabel.font = endBtnFont;
		resetLabel.setFillText("NewGame");
		resetBtn.addChild(resetLabel);

		continueBtn.loadBitmap("media/images/buttons/btnLarge.png");
		continueBtn.x = 814;
		continueBtn.y = 672; // 538;
		continueBtn.alpha = 0;
		continueBtn.releasedState = function(){
			this.loadBitmap("media/images/buttons/btnLarge.png");
		};
		continueBtn.pressedState = function(){
			this.loadBitmap("media/images/buttons/btnLargePressed.png");
		};
		this.addChild(continueBtn);

		continueLabel.width = 238;
		continueLabel.height = 75;
		continueLabel.y = 26;
		continueLabel.font = endBtnFont;
		continueLabel.setFillText("Continue");
		continueBtn.addChild(continueLabel);

		// Overlay

		overlayHolder.loadBitmap("media/images/backgrounds/overlayBg.png");
		overlayHolder.alpha = 0;
		overlayHolder.setIndex(2);
		this.addChild(overlayHolder);

		eraseHolder.loadBitmap("media/images/screens/confirm/panel.png");
		eraseHolder.x = 292;
		eraseHolder.y = -643; // 20
		overlayHolder.addChild(eraseHolder);

		overlayTitle.width = 420;
		overlayTitle.height = 100;
		overlayTitle.x = (579 - overlayTitle.width) / 2;
		overlayTitle.y = 66;
		overlayTitle.font = overlayTitleFont;
		overlayTitle.setStrokeText("ResetTitle");
		eraseHolder.addChild(overlayTitle);

		overlayText.width = 420;
		overlayText.height = 100;
		overlayText.x = (579 - overlayText.width) / 2;
		overlayText.y = 183;
		overlayText.font = overlayTextFont;
		overlayText.setStrokeText("ResetText");
		eraseHolder.addChild(overlayText);

		confirmResetBtn.loadBitmap("media/images/buttons/btnSmall.png");
		confirmResetBtn.x = 72;
		confirmResetBtn.y = 268;
		confirmResetBtn.releasedState = function(){
			this.loadBitmap("media/images/buttons/btnSmall.png");
		};
		confirmResetBtn.pressedState = function(){
			this.loadBitmap("media/images/buttons/btnSmallPressed.png");
		};
		eraseHolder.addChild(confirmResetBtn);

		confirmResetLabel.width = 169;
		confirmResetLabel.height = 70;
		confirmResetLabel.font = overlayBtnFont;
		confirmResetLabel.setStrokeText("Yes");
		confirmResetBtn.addChild(confirmResetLabel);

		cancelResetBtn.loadBitmap("media/images/buttons/btnSmall.png");
		cancelResetBtn.x = 336;
		cancelResetBtn.y = 268;
		cancelResetBtn.releasedState = function(){
			this.loadBitmap("media/images/buttons/btnSmall.png");
		};
		cancelResetBtn.pressedState = function(){
			this.loadBitmap("media/images/buttons/btnSmallPressed.png");
		};
		eraseHolder.addChild(cancelResetBtn);

		cancelResetLabel.width = 169;
		cancelResetLabel.height = 70;
		cancelResetLabel.font = overlayBtnFont;
		cancelResetLabel.setStrokeText("No");
		cancelResetBtn.addChild(cancelResetLabel);

		// Methods
		
		this.onload = function(){
			GameData.set("goToEnd", false, true);
			setTimeout(function(){ Tween.add(resetBtn, { alpha: 1, y: 538 }, 8, 0.7, function(){ }); }, 500);
			setTimeout(function(){ Tween.add(continueBtn, { alpha: 1, y: 538 }, 8, 0.7, function(){ }); }, 600);
		};	
		
		this.update = function(){};
		
		this.onunload = function(){};

		this.continue = function(){
			if(isOverlay) return;

			EventManager.broadcast("gotoScreen", "story");
		};

		this.showOverlay = function(){
			if(isOverlay) return;

			setTimeout(function(){ Tween.add(overlayHolder, { alpha: 1 }, 12, 0.5, function(){
				setTimeout(function(){ Tween.add(eraseHolder, { y: 20 }, 12, 0.5, function(){ isOverlay = true; }); }, 100);

			}); }, 50);
		};

		this.hideOverlay = function(){
			setTimeout(function(){ Tween.add(eraseHolder, { y: -643 }, 12, 0.5, function(){
				setTimeout(function(){ Tween.add(overlayHolder, { alpha: 0 }, 12, 0.5, function(){ isOverlay = false; }); }, 50);

			}); }, 100);
		};

		this.reset = function(){
			thisRef.setDefaultLocalStorage();

			EventManager.broadcast("gotoScreen", "story");
		};

		this.setDefaultLocalStorage = function(){
			GameData.set("firstTime", "false", true);
			GameData.set("tutDone", "false", true);
			GameData.set("muted", "false", true);

			GameData.set("showTutorial", "true", true);

			GameData.set("levelUnlocked", 4, true);
			GameData.set("goToEnd", true, true);

			GameData.set("level1Highscore", 0, true);
			GameData.set("level1Star", 0, true);
			GameData.set("level1Note", 0, true);
			GameData.set("level1Token1", "false", true);
			GameData.set("level1Token2", "false", true);
			GameData.set("level1Token3", "false", true);
			GameData.set("level1Token4", "false", true);
			GameData.set("level1Token5", "false", true);
			GameData.set("level2Highscore", 0, true);
			GameData.set("level2Star", 0, true);
			GameData.set("level2Note", 0, true);
			GameData.set("level2Token1", "false", true);
			GameData.set("level2Token2", "false", true);
			GameData.set("level2Token3", "false", true);
			GameData.set("level2Token4", "false", true);
			GameData.set("level2Token5", "false", true);
			GameData.set("level3Highscore", 0, true);
			GameData.set("level3Star", 0, true);
			GameData.set("level3Note", 0, true);
			GameData.set("level3Token1", "false", true);
			GameData.set("level3Token2", "false", true);
			GameData.set("level3Token3", "false", true);
			GameData.set("level3Token4", "false", true);
			GameData.set("level3Token5", "false", true);

			GameData.set("artistsToGet1", JSON.stringify(thisRef.shuffle([1,2,3,4,5])), true);
			GameData.set("artistsToGet2", JSON.stringify(thisRef.shuffle([1,2,3,4,5])), true);
			GameData.set("artistsToGet3", JSON.stringify(thisRef.shuffle([1,2,3,4,5])), true);
			GameData.set("artistsToGet4", JSON.stringify(thisRef.shuffle([6])), true);
		};

		this.shuffle = function(o){
		    for(var j, x, i = o.length; i; j = Math.floor(Math.random() * i), x = o[--i], o[i] = o[j], o[j] = x);
		    return o;
		};
		
		this.binds = {
			"continue": thisRef.continue,
			"reset": thisRef.showOverlay,
			"cancelReset": thisRef.hideOverlay,
			"confirmReset": thisRef.reset
		};
	};
	
	return screen;
});