define("screens/popupWin2015", [
	"utils/Background",
	"sdk/EventManager",
	"sdk/DisplayObject",
	"sdk/TextField",
	"sdk/GameData",
	"sdk/Sound",
	"sdk/Tween",
	"text/Font",
	"text/Gradient"
], 
function (Background, EventManager, DisplayObject, TextField, GameData, Sound, Tween, Font, Gradient){
	var screen = function(){
		var thisRef = this,
			// Local
			score = GameData.get('scoreTotal'),
			highscore = GameData.get("level" + GameData.get("selectedLevel") + "Highscore", true),
			note =  GameData.get('notePercentage'),
			token = parseInt(GameData.get("tokenFound"), 10),
			star =  GameData.get('starTotal'),
			goToEnd = true,
			// Styles
			overlayTitleFont = new Font("overlayTitleFont"),
			overlayTextLeftFont = new Font("overlayTextLeftFont"),
			overlayTextRightFont = new Font("overlayTextRightFont"),
			// Elements
			overlayHolder = new DisplayObject("overlayHolder"),
			winHolder = new DisplayObject("winHolder"),
				overlayTitle = new TextField("overlayTitle"),
				overlayScore = new TextField("overlayScore"),
				overlayScoreValue = new TextField("overlayScoreValue"),
				overlayHighscore = new TextField("overlayHighscore"),
				overlayHighscoreValue = new TextField("overlayHighscoreValue"),
				overlayNote = new TextField("overlayNote"),
				overlayNoteValue = new TextField("overlayNoteValue"),
				overlayArtistFound = new TextField("overlayArtistFound"),
				overlayArtistToken = new DisplayObject("overlayArtistToken"),
				overlayStar = new DisplayObject("overlayLevelStar"),
				quitGlow = new DisplayObject("quitGlow"),
				quitBtn = new DisplayObject("quit"),
				nextGlow = new DisplayObject("nextGlow"),
				nextBtn = new DisplayObject("next"),
				shareTxt = new TextField("shareTxt"),
				fbBtn = new DisplayObject("fbBtn"),
				twitBtn = new DisplayObject("twitBtn"),
				pinBtn = new DisplayObject("pinBtn")

		;
		for(var j = 1; j < 6; j++){
			for(var i = 1; i < 4; i++){
				if(GameData.get("level" + i + "Token" + j, true) == "false"){
					goToEnd = false;
				}
			}
		}
		// Fonts

		overlayTitleFont.font = "56px NexaBold";
		overlayTitleFont.fillStyle = "#ffce33";
		overlayTitleFont.textBaseline = "alphabetical";
		overlayTitleFont.paddingTop = 56;
		overlayTitleFont.textAlign = "center";

		overlayTextLeftFont.font = "30px NexaBold";
		overlayTextLeftFont.fillStyle = "#ff4ef9";
		overlayTextLeftFont.textBaseline = "alphabetical";
		overlayTextLeftFont.paddingTop = 30;
		overlayTextLeftFont.textAlign = "left";
		overlayTextLeftFont.shadowColor = "60D5FF";
		overlayTextLeftFont.shadowBlur = 5;

		overlayTextRightFont.font = "30px NexaBold";
		overlayTextRightFont.fillStyle = "#ff4ef9";
		overlayTextRightFont.textBaseline = "alphabetical";
		overlayTextRightFont.paddingTop = 30;
		overlayTextRightFont.textAlign = "right";
		overlayTextRightFont.shadowColor = "60D5FF";
		overlayTextRightFont.shadowBlur = 5;


		var tokenTxtFont = new Font();
			tokenTxtFont.font = "22px NexaBold";
			tokenTxtFont.fillStyle = "#ffce33";
			tokenTxtFont.textBaseline = "alphabetical";
			tokenTxtFont.paddingTop = 22;
			tokenTxtFont.textAlign = "center";
			tokenTxtFont.textWrap = true;

		var shareFont = new Font();
			shareFont.font = "18px NexaBold";
			shareFont.fillStyle = "#fff";
			shareFont.textBaseline = "alphabetical";
			shareFont.paddingTop = 18;
			shareFont.textAlign = "center";
		
		// Default

		// Overlay

		overlayHolder.loadBitmap("media/images/screens/win/bg.png");
		overlayHolder.alpha = 0;
		overlayHolder.setIndex(2);
		this.addChild(overlayHolder);

		winHolder.loadBitmap("media/images/screens/win/panel2015.png");
		winHolder.x = 292;
		winHolder.y = -643; // 20
		overlayHolder.addChild(winHolder);

		var tokenTxt = new TextField("tokenTxt");
			tokenTxt.width = 560;
			tokenTxt.height = 100;
			tokenTxt.x = 290;
			tokenTxt.y = 540;
			tokenTxt.scaleX = 0;
			tokenTxt.scaleY = 0;
			tokenTxt.setFillText("replayTokenAll",{"%%":GameData.get("selectedLevel")});
			tokenTxt.font = tokenTxtFont;
			
			for(var j = 1; j < 6; j++){
				if(GameData.get("level" + GameData.get("selectedLevel") + "Token" + j, true) == "false"){
					tokenTxt.x = 290 - tokenTxt.width * 0.5;
					tokenTxt.y = 540;
					tokenTxt.scaleX = 1;
					tokenTxt.scaleY = 1;
					tokenTxt.setFillText("replayToken");
				}
			}
		winHolder.addChild(tokenTxt);

		overlayTitle.width = 420;
		overlayTitle.height = 100;
		overlayTitle.x = (579 - overlayTitle.width) / 2;
		overlayTitle.y = 66;
		overlayTitle.font = overlayTitleFont;
		overlayTitle.setStrokeText("WinTitle");
		winHolder.addChild(overlayTitle);

		replayGlow= new DisplayObject("replayGlow"),
		replayGlow.loadBitmap("media/images/buttons/btnGlow.png");
		replayGlow.x = 111;
		replayGlow.y = 250;
		replayGlow.alpha = 0;
		overlayHolder.addChild(replayGlow);

		replayBtn = new DisplayObject("replay"),
		replayBtn.loadBitmap("media/images/buttons/btnReplay2015.png");
		//replayBtn.x = 40;
		//replayBtn.y = 40;
		replayBtn.releasedState = function(){
			this.loadBitmap("media/images/buttons/btnReplay2015.png");
		};
		replayBtn.pressedState = function(){
			this.loadBitmap("media/images/buttons/btnReplay2015Pressed.png");
		};
		replayGlow.addChild(replayBtn);

		quitGlow.loadBitmap("media/images/buttons/btnGlow.png");
		quitGlow.x = 842;
		quitGlow.y = 250;
		quitGlow.alpha = 0;
		overlayHolder.addChild(quitGlow);

		quitBtn.loadBitmap("media/images/buttons/btnMenu2015.png");
		//quitBtn.x = 40;
		//quitBtn.y = 40;
		quitBtn.releasedState = function(){
			this.loadBitmap("media/images/buttons/btnMenu2015.png");
		};
		quitBtn.pressedState = function(){
			this.loadBitmap("media/images/buttons/btnMenu2015Pressed.png");
		};
		quitGlow.addChild(quitBtn);

		nextGlow.loadBitmap("media/images/buttons/btnGlow.png");
		nextGlow.x = 842;
		nextGlow.y = 250;
		nextGlow.alpha = 0;
		overlayHolder.addChild(nextGlow);

		nextBtn.loadBitmap("media/images/buttons/btnPlay2015.png");
		//nextBtn.x = 40;
		//nextBtn.y = 40;
		nextBtn.releasedState = function(){
			this.loadBitmap("media/images/buttons/btnPlay2015.png");
		};
		nextBtn.pressedState = function(){
			this.loadBitmap("media/images/buttons/btnPlay2015Pressed.png");
		};
		if(GameData.get("selectedLevel") != 6){
			quitGlow.y = 12;
			nextGlow.addChild(nextBtn);
		}

		overlayScore.width = 200;
		overlayScore.height = 80;
		overlayScore.x = 100;
		overlayScore.y = 190;
		overlayScore.font = overlayTextLeftFont;
		overlayScore.setFillText("Score");
		winHolder.addChild(overlayScore);

		overlayScoreValue.width = 200;
		overlayScoreValue.height = 80;
		overlayScoreValue.x = 295;
		overlayScoreValue.y = 190;
		overlayScoreValue.font = overlayTextLeftFont;
		overlayScoreValue.setFillText(" " + score);
		winHolder.addChild(overlayScoreValue);

		overlayHighscore.width = 200;
		overlayHighscore.height = 80;
		overlayHighscore.x = 100;
		overlayHighscore.y = 225;
		overlayHighscore.font = overlayTextLeftFont;
		overlayHighscore.setFillText("Highscore");
		winHolder.addChild(overlayHighscore);

		overlayHighscoreValue.width = 200;
		overlayHighscoreValue.height = 80;
		overlayHighscoreValue.x = 295;
		overlayHighscoreValue.y = 225;
		overlayHighscoreValue.font = overlayTextLeftFont;
		overlayHighscoreValue.setFillText(" " + highscore);
		winHolder.addChild(overlayHighscoreValue);

		overlayNote.width = 200;
		overlayNote.height = 80;
		overlayNote.x = 100;
		overlayNote.y = 260;
		overlayNote.font = overlayTextLeftFont;
		overlayNote.setFillText("Note");
		winHolder.addChild(overlayNote);

		overlayNoteValue.width = 200;
		overlayNoteValue.height = 80;
		overlayNoteValue.x = 295;
		overlayNoteValue.y = 260;
		overlayNoteValue.font = overlayTextLeftFont;
		overlayNoteValue.setFillText("NoteValue", { "%%": note });
		winHolder.addChild(overlayNoteValue);

		if(token > 0){
			overlayArtistFound.width = 270;
			overlayArtistFound.height = 80;
			overlayArtistFound.x = 100;
			overlayArtistFound.y = 350;
			overlayArtistFound.alpha = 0;
			overlayArtistFound.font = overlayTextLeftFont;
			overlayArtistFound.setFillText("ArtistTokenFound");
			winHolder.addChild(overlayArtistFound);

			overlayArtistToken.loadBitmap("media/images/artists/collectionToken" + token + "_2015.png");
			overlayArtistToken.x = 375 + 140*0.5;
			overlayArtistToken.y = 275 + 141*0.5;
			overlayArtistToken.scaleX = 0;
			overlayArtistToken.scaleY = 0;
			winHolder.addChild(overlayArtistToken);
		}

		overlayStar.loadBitmap("media/images/screens/win/star2015_" + 0 + ".png");
		overlayStar.x = 177;
		overlayStar.y = 393;
		winHolder.addChild(overlayStar);

		/*shareTxt.width = 200;
		shareTxt.height = 70;
		shareTxt.x = (579 - shareTxt.width) * 0.5;
		shareTxt.y = 508;
		shareTxt.font = shareFont;
		shareTxt.setFillText("share");
		winHolder.addChild(shareTxt);

		fbBtn = new DisplayObject("fbBtn"),
		fbBtn.loadBitmap("media/images/screens/win/fb.png");
		fbBtn.x = 202;
		fbBtn.y = 530;
		winHolder.addChild(fbBtn);

		twitBtn = new DisplayObject("twitBtn"),
		twitBtn.loadBitmap("media/images/screens/win/twit.png");
		twitBtn.x = 266;
		twitBtn.y = 530;
		winHolder.addChild(twitBtn);

		pinBtn = new DisplayObject("pinBtn"),
		pinBtn.loadBitmap("media/images/screens/win/pin.png");
		pinBtn.x = 326;
		pinBtn.y = 530;
		winHolder.addChild(pinBtn);*/

		// Methods
		
		this.onload = function(){
			thisRef.showOverlay();
			thisRef.bgMusic = new Howl({
				urls:['media/music/win.mp3','media/music/win.ogg'],
				autoplay:true
			});
			thisRef.sfx = new Howl({
				urls:['media/music/audiosprite.mp3','media/music/audiosprite.ogg'],
				sprite:{
					Sfx_life_pick_up:[7110,2120]
				},
			});
			
			if(GameData.get("muted", true) == "true"){
				thisRef.sfx.volume(0);
				thisRef.bgMusic.volume(0);
			}

			
		};	
		
		this.update = function(){};
		
		this.onunload = function(){
			try{
				window.gameObj.closeSharing();
				//window.gameObj.startGame();
			}
			catch(e){
				console.log("Disney overlay failure");
			}
		};

		this.showOverlay = function(){
			setTimeout(function(){ Tween.add(overlayHolder, { alpha: 1 }, 12, 0.5, function(){
				setTimeout(function(){ Tween.add(winHolder, { y: 20 }, 12, 0.5, function(){
					Tween.add(quitGlow, { alpha: 1 }, 12, 0.5, function(){});
					Tween.add(replayGlow, { alpha: 1 }, 12, 0.5, function(){});
					thisRef.btnFadeIn();
				}); }, 100);
				
				thisRef.showStars();
				thisRef.showSharing();

			}); }, 50);
		};

		this.showStars = function(){
				if(star >= 1){
					setTimeout(function(){
						overlayStar.loadBitmap("media/images/screens/win/star2015_" + 1 + ".png");
						thisRef.sfx.play('Sfx_note_pick_up');
					},500);
				}
				if(star >= 2){
					setTimeout(function(){
						overlayStar.loadBitmap("media/images/screens/win/star2015_" + 2 + ".png");
						thisRef.sfx.play('Sfx_note_pick_up');
					},900);
				}
				if(star == 3){
					setTimeout(function(){
						overlayStar.loadBitmap("media/images/screens/win/star2015_" + 3 + ".png");
						thisRef.sfx.play('Sfx_note_pick_up');
					},1300);
				}
				if(token > 0){
					setTimeout(function(){
						overlayArtistFound.alpha = 1;
						Tween.add(overlayArtistToken, { scaleX: 0.9, scaleY: 0.9, x:375 ,y:275 }, 15, 1);
						for(var j = 1; j < 6; j++){
							if(GameData.get("level" + GameData.get("selectedLevel") + "Token" + j, true) == "true"){
								//Tween.add(tokenTxt, { scaleX: 1, scaleY: 1, x:290 - tokenTxt.width * 0.5 ,y:530 }, 15, 1);
							}
						}
					},1700);
				}
		}

		this.showSharing = function() {
			if(GameData.get("sharing"))
			{
				//try{
					window.gameObj.showSharing(score,470,500);
				/*}
				catch(e){
					console.log("Disney overlay failure");
				}*/
			}
		};

		this.btnFadeIn = function(){
			setTimeout(function(){ Tween.add(nextGlow, { alpha: 1 }, 10, 0.75, function(){ thisRef.btnFadeOut(); }); }, 100);
		};

		this.btnFadeOut = function(){
			setTimeout(function(){ Tween.add(nextGlow, { alpha: 0.25 }, 10, 0.75, function(){ thisRef.btnFadeIn(); }); }, 100);
		};

		this.quit = function(){
			if(goToEnd == true && GameData.get("goToEnd", true) == "true"){
				EventManager.broadcast("gotoScreen", "end");
				return;
			}
			if(GameData.get("selectedLevel")>3){
				EventManager.broadcast("gotoScreen", "chooseLevel2015");
			}else{
				EventManager.broadcast("gotoScreen", "chooseLevel");
			}
			thisRef.bgMusic.unload();
		};

		this.next = function(){
			if(goToEnd == true && GameData.get("goToEnd", true) == "true"){
				EventManager.broadcast("gotoScreen", "end");
				return;
			}
			var level = parseInt(GameData.get("selectedLevel", false), 10);

			GameData.set("selectedLevel", level + 1, false);

			EventManager.broadcast("gotoScreen", "gameplay");
			thisRef.bgMusic.unload();
		};

		this.replay = function(){
			EventManager.broadcast("gotoScreen", "gameplay");
			thisRef.bgMusic.unload();
		};
		
		this.binds = {
			"quit": thisRef.quit,
			"next": thisRef.next,
			"replay": thisRef.replay
		};
	};
	
	return screen;
});