define("screens/story", [
	"utils/Background",
	"sdk/EventManager",
	"sdk/DisplayObject",
	"sdk/TextField",
	"sdk/GameData",
	"sdk/Sound",
	"text/Font",
	"text/Gradient",
	"sdk/Tween"
], 
function (Background, EventManager, DisplayObject, TextField, GameData, Sound , Font, Gradient, Tween){
	var screen = function(){
		var thisRef = this,
			// Local
			// Styles
			textFont = new Font("textFont"),
			// Elements
			text = new TextField("text"),
			nextBtn = new DisplayObject("next")
		;
		
		Background.set("media/images/screens/story/bg.jpg");
				
		// Fonts

		textFont.font = "italic 24px NexaBold";
		textFont.fillStyle = "#fff";
		textFont.textBaseline = "alphabetical";
		textFont.paddingTop = 24;
		textFont.textAlign = "center";
		textFont.strokeStyle = "#FFFFBE";
		textFont.lineWidth = 5;
		textFont.lineJoin = "round";
		textFont.shadowColor = "rgba(174,148,0,0.3)";
		textFont.shadowBlur = 6;
		textFont.textWrap = true;
		
		// Default

		text.width = 720;
		text.height = 100;
		text.x = 568 - text.width * 0.5;
		text.y = 515;
		text.font = textFont;
		text.setFillText("StoryText");
		this.addChild(text);

		nextBtn.loadBitmap("media/images/buttons/btnNext.png");
		nextBtn.x = 963;
		nextBtn.y = 498;
		nextBtn.alpha = 0;
		nextBtn.releasedState = function(){
			this.loadBitmap("media/images/buttons/btnNext.png");
		};
		nextBtn.pressedState = function(){
			this.loadBitmap("media/images/buttons/btnNextPressed.png");
		};
		this.addChild(nextBtn);

		// Methods
		this.btnFadeIn = function(){
			setTimeout(function(){ Tween.add(nextBtn, { alpha: 1 }, 20, 1, function(){ thisRef.btnFadeOut(); }); }, 100);
		};

		this.btnFadeOut = function(){
			setTimeout(function(){ Tween.add(nextBtn, { alpha: 0.5 }, 20, 1, function(){ thisRef.btnFadeIn(); }); }, 100);
		};

		this.btnFadeIn();
		
		this.onload = function(){};	
		
		this.update = function(){};
		
		this.onunload = function(){};

		this.next = function(){
			EventManager.broadcast("gotoScreen", "chooseLevel2015");
		};
		
		this.binds = {
			"next": thisRef.next
		};
	};
	
	return screen;
});