/**
 * Fixed Display Object. 
 * 
 * Doesn't try to re-order children by redundant index property
 * (which was slow, as well as unstable in Chrome).
 * Was considering giving it a stable sort
 * and only making it sort if .index is assigned,
 * but since I have to choose to use this class manually anyway,
 * and I never use .index in-game,
 * I'll just leave it out
 *
 * @author Andrew Fraticelli <andrewf@meetfidel.com>
 */
;(function(window){

	/**
	 * AMD Closure
	 */	
	if ( typeof define === "function" && define.amd ) {
		define( "sdkcustom/DisplayObjectFixed", ["sdk/DisplayObject"], function (DisplayObject) {
			
			Arstider.Inherit(DisplayObjectFixed, DisplayObject);
			function DisplayObjectFixed(name, keepAssetBuffer){
				Arstider.Super(this, DisplayObject, name, keepAssetBuffer);
			}
			
			DisplayObjectFixed.prototype.addChild = function(clip) {
				clip.parent = this;
				this.children.push(clip);
				return this.children.length-1;
			}
			
			return DisplayObjectFixed;
			
		});
	}
	else{
		rjsError("DisplayObjectFixed");
	}
})(window);