// this should probably be static, or be part of the engine, rather than just being an instantiable object, but this will do for now
;(function(window){
	
	if ( typeof define === "function" && define.amd ) {
		define( "sdkcustom/KeyStates", [], function () {
			
			function KeyStates(){
				
				this.keysDown = [];
				this.keysHeld = [];
				this.keysUp = [];
				
				for(var i=0; i<256; i++) {
					this.keysDown[i] = false;
					this.keysHeld[i] = false;
					this.keysUp[i] = false;
				}
				
				// call this on frame END to wipe out down/up status
				this.update = function(){
					for(var i=0; i<256; i++) {
						this.keysDown[i] = false;
						this.keysUp[i] = false;
					}
				}
				
				var theThis = this;
				this.keyDownListener = function(e){
					if (!theThis.keysHeld[e.keyCode]) theThis.keysDown[e.keyCode] = true;
					theThis.keysHeld[e.keyCode] = true;
				};
				this.keyUpListener = function(e){
					if (theThis.keysHeld[e.keyCode]) theThis.keysUp[e.keyCode] = true;
					theThis.keysHeld[e.keyCode] = false;
				};
				
				window.addEventListener('keydown', this.keyDownListener);
				window.addEventListener('keyup', this.keyUpListener);
				
				this.dispose = function(){
					window.removeEventListener('keydown', this.keyDownListener);
					window.removeEventListener('keyup', this.keyUpListener);
				}
				
			}
			
			return KeyStates;
			
		});
	}
	else{
		rjsError("KeyStates");
	}
})(window);